 import ee.ut.kiho.aa.graaf.*;
 import java.util.Vector;
 class Main  {
 public static void main(String[] args){
         // Algoritmid ja andmestruktuurid
         // Kodut nr 7
         // TEEDE OTSIMINE LABRINDIS
         // Labrint on esitatud 0-1-maatriksina, 0-element on vaba koht.
         // Astuda uuele kohale saab maatriksi piires les, alla, vasakule, paremale,
         // tingimusel, et sihtkoht ei ole 1-element.
         // lesandeks on leida teid antud lhtekohast antud sihtkohta.
        
         // Autorid:
         // .            lli pilane --   otsida_teed (kik teed, sgavuti),
         // .                                   lbida_Dijkstra,
         // .                                   ja vastavad testiosad ning omaloodud nitelabrint
         // .           Jri Kiho     --   muu (maatriks_graafiks, lbida_laiuti,
         // .                                   lbida_Bellman_Ford, ...)
                    boolean juhu = true; // servadele juhu-raskused
                    //juhu = false; // konst. raskused (==1)
                    
                    int[][] L = {{1, 0, 0}, {0, 1, 0}, {0, 0, 0}, {0, 0, 0}};
                    int[] algus = {0, 1}; // otsitava tee alguselemendi indeksid
                    int[] lpp  = {3, 0}; // otsitava tee lppelemendi indeksid
                     // ---------------------------------------------------------------------
                    //int[][] L = {{0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1, 1},{0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0},{0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 1, 0},{0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0}};
                    //int[] algus = {1, 2}; // otsitava tee alguselemendi indeksid
                    //int[] lpp  = {2, 12}; // otsitava tee lppelemendi indeksid
                     // ---------------------------------------------------------------------
                    //int[][] L = {{1, 0, 1, 1, 0, 0, 0, 0, 1},{0, 0, 0, 0, 0, 0, 0, 1, 0},{0, 1, 0, 1, 0, 0, 1, 0, 0},{0, 0, 0, 0, 1, 0, 0, 0, 1},{0, 1, 0, 0, 1, 0, 0, 0, 1},{1, 0, 1, 0, 1, 1, 0, 0, 0},{0, 0, 0, 0, 0, 0, 1, 0, 0}};
                    //int[] algus = {4, 0}; // otsitava tee alguselemendi indeksid
                    //int[] lpp  = {2, 7}; // otsitava tee lppelemendi indeksid
                     // ---------------------------------------------------------------------
                    int m = L.length; // maatriksi ridade arv
                    int n = L[0].length; // maatriksi veergude arv
                    System.out.print("   ");
          for( int j = 0; j <= n-1; j++ )
          {
                          System.out.print(" " + j +":");
          }
                    System.out.println();
          for( int i = 0; i <= m-1; i++ )
          {
                          System.out.print(i + ":");
             for( int j = 0; j <= n-1; j++ )
             {
                                System.out.print("  "+ L[i][j]);
             }
                          System.out.println();
          }
                    Graaf g = maatriks_graafiks(L, juhu);
                    g.vljastadaTabelina("xxx.txt");
                    new GraafiJoonistaja("xxx.txt");
                    int ii = algus[0];
                    int jj = algus[1];
                    int a_nr = ii*n + jj + 1; // lhtetipu number
                    ii = lpp[0];
                    jj = lpp[1];
                    int b_nr = ii*n + jj + 1; // sihttipu number
                    System.out.println("Tee algus ja lopp massiivis: (" + algus[0] + "; " + algus[1] +") "  + "ja (" + lpp[0] + "; " + lpp[1] +") ");
                    System.out.println("Tee algus- ja lopptipu numbrid graafis:  " + a_nr + " ja " + b_nr);
        Tipp lhtetipp = g.tipp(a_nr-1);
        Tipp sihttipp = g.tipp(b_nr-1);
                    
                    System.out.println("\n----------------- OTSETEE ---------------------");
                    long algusaeg = System.nanoTime(); // -------------
                    lbida_laiuti(g, lhtetipp);
                    long lpuaeg = System.nanoTime(); // -------------
                    double aeg_ms = ((lpuaeg-algusaeg)/1000000.0); // kulunud aeg millisekundites
                    System.out.println("Aega kulus "+ Math.round(aeg_ms*100)/100.0 + " millisekundit.");
                    Object[]  sum_tt = tipud_teel(g, sihttipp);
                    Double sum = (Double)sum_tt[0];
                    Vector<Tipp> tee = (Vector<Tipp>)sum_tt[1];
                    String fTulem = "xxxgr_otse.txt";
                    graaf_leitud_teega_faili(g, tee, fTulem);
                    new GraafiJoonistaja(fTulem, false);
                     // eemaldadaTipuvljad(g) :
          for( int i = 0; i <= g.n()-1; i++ )
          {
                          Tipp t = g.tipp(i);
                          t.seadaMrgend(t.mrgend00());
          }
          if(tee.size() == 1)
          {
                          System.out.print("\nTeed ei leidu!");
          }
          else
          {
                          System.out.println("\nLeitud otsetee tipunumbrid on: ");
             for (Tipp t : tee)
             {
                                System.out.print(" " + g.indeks(t) + 1);
             }
                          System.out.println("\n" + (tee.size()-1) + " serva, ");
                          System.out.println("koguraskus: "+  sum);
          }
                    
                    System.out.println("\n----------------- BELLMAN-FORD ---------------");
                    algusaeg = System.nanoTime(); // -------------
                    lbida_Bellman_Ford(g, lhtetipp);
                    lpuaeg = System.nanoTime(); // -------------
                    aeg_ms = ((lpuaeg-algusaeg)/1000000.0); // kulunud aeg millisekundites
                    System.out.println("Aega kulus "+ Math.round(aeg_ms*100)/100.0 + " millisekundit.");
                    sum_tt = tipud_teel(g, sihttipp);
                    sum = (Double)sum_tt[0];
                    tee = (Vector<Tipp>)sum_tt[1];
                    fTulem = "xxxgr_B_F.txt";
                    graaf_leitud_teega_faili(g, tee, fTulem);
                    new GraafiJoonistaja(fTulem, false);
                     // eemaldadaTipuvljad(g) :
          for( int i = 0; i <= g.n()-1; i++ )
          {
                          Tipp t = g.tipp(i);
                          t.seadaMrgend(t.mrgend00());
          }
          if(tee.size() == 1)
          {
                          System.out.print("\nTeed ei leidu!");
          }
          else
          {
                          System.out.println("\nLeitud kergeima tee tipunumbrid on: ");
             for (Tipp t : tee)
             {
                                System.out.print(" " + g.indeks(t) + 1);
             }
                          System.out.println("\n" + (tee.size()-1) + " serva, ");
                          System.out.println("koguraskus: "+  sum);
          }
                    System.out.print("============================== Valmis.");
       }
       static void lbida_laiuti(Graaf g, Tipp a)
       {
                     // [AA Kiho 2003, lk 106-107, joonis 6.12] Vlja .vaadeldud ei kasutata:
                     // tipp on vaadeldud, kui talle on seatud vli .eellane
                     // Antud:  graaf g = (V, E) ja lhtetipp a,
                     // .          millest alustada g tippude lbimist;
                     // Tulemus:  on salvestatud tipuvljadesse .eellane jrgmiselt:
                     // .              iga tipu v (!=a) korral, mis on saavutatav tipust a
                     // .                 v.eellane on v-le eelnev tipp (tipu number)  otseteel a..v;
                    a.seadaVli("eellane", "0");
                    Vector<Tipp> Q = new Vector<Tipp>();
                    Q.add(a);
          while (Q.size() != 0)
          {
                          Tipp v = Q.remove(0);
             for(Tipp w : g.naabrid(v))
             {
                                 // kaar on v-->w
                if(w.vli("eellane") == null)
                {
                                      w.seadaVli("eellane", "" + (g.indeks(v)+1)); // tipu number
                                      Q.add(w);
                }
             }
          }
                    a.eemaldadaVli("eellane");
       }
          static boolean lbida_Bellman_Ford(Graaf g, Tipp a)
          {
                           // [AA Kiho 2003, lk 102-104, joonis 6.10]
                           // Antud: graaf g = (V, E) ja lhtetipp a, millest alustada;
                           // .          g igal kaarel (v, w) on pikkus c(v, w) >= 0;
                           // .          kaare pikkus vib ka puududa: (v, w).nimi == "",
                           // .          siis loetakse pikkuseks 1.0
                           // Tulemus:  tagastatakse false, kui mne tipu kaugus lhtetipust on -lpmatus;
                           // .              vastasel koraal tagastatakse true ning siis graafis g
                           // .              iga tipust a saavuatatva tipu v korral on v.d lhima tee a...v pikkus ja
                           // .              v.eellane on v-le eelnev tipp (tipu number)  sellel teel;
                           // .              kui tipp v ei ole algustipust saavutatav, siis v.d = +lpmatus
                           // .              ja vli v.eellane puudub; ka a.eellane puudub
                          parandada_kaugused_Bellman_Ford(g, a);
             for( int i = 0; i <= g.m()-1; i++ )
             {
                                Kaar vw = g.kaar(i);
                                Tipp v = vw.algus();
                                Tipp w = vw.lpp();
                                //uus_kaugus = int(v.vli("d")) + int(vw.nimi) ;
                                double uus_kaugus = Double.parseDouble(v.vli("d")) + ((vw.nimi() != "") ? Double.parseDouble(vw.nimi()) : 1.0);
                if(uus_kaugus < Double.parseDouble(w.vli("d")))
                {
                                      w.seadaVli("eellane", "" + g.indeks(v)+ 1);
                                      w.seadaVli("d", "" + uus_kaugus);
                                      return false;
                }
             }
                          return true;
          }
          static void parandada_kaugused_Bellman_Ford(Graaf g, Tipp a)
          {
                           // [AA Kiho 2003, lk 102-104, joonis 6.8]
                           // Antud: graaf g = (V, E) ja lhtetipp a, millest alustada;
                           // .          g igal kaarel (v, w) on pikkus c(v, w) >= 0;
                           // .          kaare pikkus vib ka puududa: (v, w).nimi == "",
                           // .          siis loetakse pikkuseks 1.0
                           // Tulemus:  on salvestatud tipuvljadesse .d ja .eellane jrgmiselt:
                           // .              iga tipu v korral on v.d lhima tee a...v pikkus ja
                           // .              v.eellane on v-le eelnev tipp (tipu number)  sellel teel;
                           // .              kui tipp v ei ole algusipust saavutatav, siis v.d = +lpmatus
                           // .              ja vli v.eellane puudub; ka a.eellane puudub
             for( int i = 0; i <= g.n()-1; i++ )
             {
                                g.tipp(i).seadaVli("d", "99999999.0");
             }
                          a.seadaVli("d", "0.0");
             for( int i = 1; i <= g.m()-1; i++ )
             {
                for( int j = 0; j <= g.m()-1; j++ )
                {
                                      Kaar vw = g.kaar(j);
                                      Tipp v = vw.algus();
                                      Tipp w = vw.lpp();
                                      //uus_kaugus = int(v.vli("d")) + int(vw.nimi) ;
                                      double uus_kaugus = Double.parseDouble(v.vli("d")) + ((vw.nimi() != "") ? Double.parseDouble(vw.nimi()) : 1.0);
                   if (uus_kaugus < Double.parseDouble(w.vli("d")))
                   {
                                            w.seadaVli("eellane", "" + (g.indeks(v)+1));
                                            w.seadaVli("d", "" + uus_kaugus);
                   }
                }
             }
          }
          static Object[] tipud_teel(Graaf g, Tipp b)
          {
                           // Antud: graaf g ja selle tipp b; g kaarte nimedeks on int/doulbe arvud (kaarepikkkused)
                           // .          graafis on seatud tipuvljad "eellane"
                           // .       NB! Kui kaare (arvulist) pikkust ei ole, loetakse see =1.0
                           // Tulemus: leitakse nende tippude list T kuhu jutakse tipust b mda eellasi
                           // .             tagasi liikudes, kuni tipuni, millel vli "eellane" puudub
                           // .     tagastatakse paar S, T', kus T' = revers T ja S on teel T olevate
                           // .             kaarte pikkuste summa (st tee T kogupikkus)
                          Vector<Tipp> tee_tipud = new Vector();
                          tee_tipud.add(b);
                          double tee_pikkus = 0;
             while (b.vli("eellane") != null)
             {
                                Tipp bb = b;
                                 // b viia oma eellasele:
                                b = g.tipp(Integer.parseInt(b.vli("eellane"))-1);
                                 // kaar teel on b->bb
                                tee_tipud.add(0, b);
                                Kaar k = g.kaar(b, bb);
                                double kaare_pikkus;
                try
                {
                                      kaare_pikkus = Double.parseDouble(k.nimi());
                }
                catch (NumberFormatException e)
                {
                                      kaare_pikkus = 1.0;
                }
                                tee_pikkus += kaare_pikkus;
             }
                          Object[] tulem = new Object[2];
                          tulem[0] = (Double)tee_pikkus;
                          tulem[1] = tee_tipud;
                          return tulem;
          }
          static Graaf maatriks_graafiks(int[][] a, boolean juhu)
          {
                           // Antud: maatriks a elementidega {0, 1}, juhu -- kas servadele juhuraskused?
                           // Tulemus: tagastatakse smmeetriline graaf, kus tipp vastab a elemendile,
                           // .             serv seob 0-tipu  naaber-0-tipuga;
                           // .             kik servade mrgendid (raskused) on 1, kui juhu = false,
                           // .             serva mrgend (raskus) on juhuarv [1;5], kui juhu = true
                           // . NB! maatriks a ei sili
                          int m = a.length; // ridade arv
                          int n = a[0].length; // veergude arv
                          Graaf g = new Graaf(); // tulemusgraaf
                          int x0 = 0; // algpunkti x
                          int y0 = 0; // algpunkti y
                          int hor =800/n; // tippude vahed hor
                          int vert = 800/m; // tippude vahed vert
                          int dx = Math.min(80, Math.min(hor, vert)); // x muut
                          int dy = dx; // y muut
                          int y = y0;
                           // teha tipud (tehtud tipp saab ka a vastavaks elemendiks):
             for( int i = 0; i <= m-1; i++ )
             {
                                int[] rida = a[i];
                                int x = x0;
                for( int j = 0; j <= n-1; j++ )
                {
                                      int elem = a[i][j];
                                      
                                      Tipp t = new Tipp();
                                      g.lisada(t);
                                      t.seadaMrgend(elem + "");
                                      t.seadaKoordinaadid(x, y);
                                      
                                      a[i][j] = g.indeks(t); // tehtud tipu  indeks a elemendiks
                                      x += dx;
                }
                                y += dy;
             }
                           // teha servad:
             for( int i = 0; i <= m-1; i++ )
             {
                for( int j = 0; j <= n-1; j++ )
                {
                   if (j > 0)
                   {
                                            Tipp t = g.tipp(a[i][j]);
                                            Tipp t1 = g.tipp(a[i][j-1]);
                      if (t.mrgend().equals("0") && t1.mrgend().equals("0"))
                      {
                                                  int raskus = (juhu) ? (int)(1 + Math.random()*(5)) : 1;
                                                  Kaar k = new Kaar(t1, t);
                                                  g.lisada(k);
                                                  k.seadaNimi(""+raskus);
                                                   // vastandkaar:
                                                  k = new Kaar(t, t1);
                                                  g.lisada(k);
                                                  k.seadaNimi(""+raskus);
                      }
                   }
                   if (i > 0)
                   {
                                            Tipp t = g.tipp(a[i][j]);
                                            Tipp t1 = g.tipp(a[i-1][j]);
                      if (t.mrgend().equals("0") && t1.mrgend().equals("0"))
                      {
                                                  int raskus = (juhu) ? (int)(1 + Math.random()*(5)) : 1;
                                                  Kaar k = new Kaar(t1, t);
                                                  g.lisada(k);
                                                  k.seadaNimi(""+raskus);
                                                   // vastandkaar:
                                                  k = new Kaar(t, t1);
                                                  g.lisada(k);
                                                  k.seadaNimi(""+raskus);
                      }
                                            
                   }
                }
             }
                          return g;
          }
          static void graaf_leitud_teega_faili(Graaf g0, Vector<Tipp> tee_tipud, String fNimi)
          {
                           // Antud: graaf g0, tee tippude loetelu tee_tipud, faili nimi fNimi
                           // Tulemus: antud faili kirjutatakse graaf, milles on kik g0 tipud,
                           // .              kaared aga esitavad antud tee
                          Graaf g1 = new Graaf(); // tulemus
                           // tipud le kanda:
             for( int i = 0; i <= g0.n()-1; i++ )
             {
                                g1.lisada(g0.tipp(i));
             }
                          
             for( int i = 0; i <= tee_tipud.size()-2; i++ )
             {
                                Tipp t1 = tee_tipud.get(i);
                                Tipp t2 = tee_tipud.get(i+1);
                                Kaar k = new Kaar(t1, t2);
                                k.seadaNimi((g0.kaar(t1, t2)).nimi());
                                g1.lisada(k);
             }
                          g1.vljastadaTabelina(fNimi);
          }
       }
